declare type Database = import('better-sqlite3').Database;
declare type RunResult = import('better-sqlite3').RunResult;
declare type MigrationRecord = import('@synor/core').MigrationRecord;
export declare type QueryStore = {
    getMigrationTableColumnNames: () => Promise<string[]>;
    createMigrationTable: () => Promise<RunResult>;
    getLock: () => Promise<void>;
    releaseLock: () => Promise<void>;
    getTableNames: () => Promise<string[]>;
    dropTables: (tableNames: string[]) => Promise<void>;
    getRecords: (startId?: number) => Promise<MigrationRecord[]>;
    addRecord: (record: Omit<MigrationRecord, 'id'>) => Promise<RunResult>;
    deleteDirtyRecords: () => Promise<RunResult>;
    updateRecord: (id: MigrationRecord['id'], data: Pick<MigrationRecord, 'hash'>) => Promise<RunResult>;
};
declare type QueryStoreOptions = {
    migrationRecordTable: string;
    schemaName: string;
};
export declare function getQueryStore(database: Database, { migrationRecordTable: tableName, schemaName }: QueryStoreOptions): QueryStore;
export {};
